#ifndef FRVFFT
#define FRVFFT

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE
#endif
/*---------------------------------------------------------------------------*/
/*  Author : B.Mours and D.Buskulic LAPP (Annecy) August 13, 2000            */
/*---------------------------------------------------------------------------*/

#include "FrameL.h"
#include "rfftw.h"

#ifdef __cplusplus
extern "C" {
#endif

struct FrvRFFT {
                             /*--------------------- input data -------------*/
  double decay;              /* decay time for averageing (could by changed) */
  long nDecay;               /* #of fft for the mean spectrum(could be reset)*/
                             /*------------------- internal data ------------*/
  long   option;             /* option used for this fft                     */
  long   nData;              /* number of data points used by the fft        */
  long   nDataP2;            /* nearest log base2 of nBin                    */
  double dt;                 /* time sampling frequency                      */
  double dnu;                /* frequency bin size                           */
  struct FrVect *window;     /* vector to hold the window                    */
  struct FrVect *output;     /* vector to hold the last data chunk           */
                             /* ------------output-------------------------  */
  double mean;               /* time serie mean value                        */
  struct FrVect *amplitude;  /* vector to hold the last amplitude spectrum   */
  struct FrVect *amplitudeA; /* vector to hold the averaged amplitude        */
  long nFFT;                 /* number of fft computed                       */
  char err[256];             /* hold error message if any                    */
  rfftw_plan plan;           /* FFTW plan                                    */
};

typedef struct FrvRFFT FrvRFFT;

void     FrvRFFTdoD(FrvRFFT *fft, FrVect *vect);
void     FrvRFFTdoF(FrvRFFT *fft, FrVect *vect);
void     FrvRFFTFree(FrvRFFT* fft);
char*    FrvRFFTGetError();
int      FrvRFFTInit(FrvRFFT *fft, FrVect *vect);
FrvRFFT* FrvRFFTNew(int option);
FrvRFFT* FrvRFFTFor(FrvRFFT *fft, FrVect *vect);

void     FrvFFTD704(double *a, long msign);

#ifdef __cplusplus
}
#endif

#endif
